/*************************************************************************/
/*                                                                       */
/*                Institut fr Maschinelle Sprachverarbeitung            */
/*                     University of Stuttgart, Germany                  */
/*                         Copyright (c) 1998                            */
/*                        All Rights Reserved.                           */
/*                                                                       */
/*  Permission to use, copy, modify, distribute this software and its    */
/*  documentation for research, educational and individual use only, is  */
/*  hereby granted without fee, subject to the following conditions:     */
/*   1. The code must retain the above copyright notice, this list of    */
/*      conditions and the following disclaimer.                         */
/*   2. Any modifications must be clearly marked as such.                */
/*   3. Original authors' names are not deleted.                         */
/*   4. It may not be redistributed in a modified version or within      */
/*      another distribution                                             */
/*  This software may not be used for commercial purposes without        */
/*  specific prior written permission from the authors.                  */
/*                                                                       */
/*  THE UNIVERSITY OF STUTTGART AND THE CONTRIBUTORS TO THIS WORK        */
/*  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      */
/*  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   */
/*  SHALL THE UNIVERSITY OF STUTTGART NOR THE CONTRIBUTORS BE LIABLE     */
/*  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    */
/*  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   */
/*  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          */
/*  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       */
/*  THIS SOFTWARE.                                                       */
/*                                                                       */
/*************************************************************************/
/*             Author :  Mark Breitenbuecher, Gregor Moehler             */
/*                       (moehler@ims.uni-stuttgart.de)                  */
/*             Date   :  June 1998                                       */
/*************************************************************************/

// DIe neue festivalversion benutzt nicht wie bisher die libg++ String
// und Regex, sondern eine eigene implementierung (definiert in
// speech_tools/include/String.h bzw. Regex.h)

#include "EST.h"  
#include "ims_patternmatcher.h"


LISP mark_l_matches_match(LISP atom, LISP regex)
{

  // returns the longest matching part of printname of atom, if atom
  // matches regex; nil otherwise.

  EST_String pname = get_c_string(atom); //neues EST_String-Objekt mit
                                         //atom-printname
  EST_Regex *rx = &make_regex(get_c_string(regex)); //neus EST_Regex-Objekt 
                                                    //mit regex init.
  if (pname.index(*rx) == 0)         //falls regex am anfang des atoms matcht
    return rintern(pname.at(*rx));          // den matchenden teil zurueckgeben
  else 
    return NIL;                      // NIL sonst
}

LISP mark_l_matches_rest(LISP atom, LISP regex)
{
  // returns the substring after the part matching regex
    EST_String pname = get_c_string(atom);  
    EST_Regex *rx = &make_regex(get_c_string(regex));
    return rintern(pname.after(*rx)); 
}












